/*
 * 	File:	main.c
 * 	Date:	2011-01-02
 */

#include "main.h"

const uint8_t Hello[] = " ZiBlog";

//-----------------------------------------------------------------------------
void delay_ms(uint16_t time)
{
	volatile uint32_t i;

	while (time-- > 0)
	{
		i = 1000;
		while (i-- > 0)
		{
		}
	}
}

volatile uint16_t test_count;

//-----------------------------------------------------------------------------
int main(void)
{
	calendar_type calendar;

	PIN_CONFIGURATION(LED_GREEN);
	PIN_CONFIGURATION(LED_BLUE);
	PIN_CONFIGURATION(BUTTON);

	lcd_2x16_init();

	mcu_rtc_init();

	mcu_tim17_init();

	interrupt_init();

	while (1)
	{
		calendar_decoder(((uint32_t)RTC->CNTH << 16) | RTC->CNTL, &calendar);

		lcd_2x16_set_position(0, 0);
		lcd_2x16_print_hex_xx(0x20);
		lcd_2x16_print_dec_xx(calendar.year);
		lcd_2x16_print_char('-');
		lcd_2x16_print_dec_xx(calendar.month);
		lcd_2x16_print_char('-');
		lcd_2x16_print_char(week_day[calendar.day_of_the_week] >> 8);
		lcd_2x16_print_char(week_day[calendar.day_of_the_week]);
		lcd_2x16_print_char('-');
		lcd_2x16_print_dec_xx(calendar.day);

		lcd_2x16_set_position(1, 0);
		lcd_2x16_print_dec_xx(calendar.hour);
		lcd_2x16_print_char(':');
		lcd_2x16_print_dec_xx(calendar.minutes);
		lcd_2x16_print_char('.');
		lcd_2x16_print_dec_xx(calendar.seconds);
		//lcd_2x16_print_string((uint8_t *) &Hello);
		lcd_2x16_print_char(':');
		lcd_2x16_print_hex_xx(TIM17->CNT >> 8);
		lcd_2x16_print_hex_xx(TIM17->CNT);
		lcd_2x16_print_char(':');
		lcd_2x16_print_hex_xx(test_count);
	}

	return 0;
}
